package org.fortiss.tooling.kernel.ui.service;

import org.fortiss.tooling.kernel.model.constraints.IConstraint;
import org.fortiss.tooling.kernel.model.constraints.IConstraintVerificationStatus;
import org.fortiss.tooling.kernel.service.IConstraintVerificationService;
import org.fortiss.tooling.kernel.ui.internal.ConstraintVerificationUIService;

/**
 * GUI aspects of {@link IConstraintVerificationService}.
 * 
 * @author aravantinos
 * @author $Author$
 * @version $Rev$
 * @ConQAT.Rating YELLOW Hash: F6AB56D17B0229C572A0C5C13C3D9789
 */
public interface IConstraintVerificationUIService {
	/**
	 * Returns the singleton instance of the service.
	 * 
	 * @deprecated
	 *             use {@link #getInstance()} instead
	 */
	@Deprecated
	public static final IConstraintVerificationUIService INSTANCE =
			new ConstraintVerificationUIService();

	/** Returns the service instance. */
	public static IConstraintVerificationUIService getInstance() {
		return INSTANCE;
	}

	/** Action to take when trying to open the given status. */
	public void openStatus(IConstraintVerificationStatus status);

	/** True if the given status can be open. */
	public boolean canOpen(IConstraintVerificationStatus status);

	/** Install the given constraint: install notifiers and triggers an "onOutdate" event. */
	public void install(IConstraint constraint);

	/** Gets a general description for the constraint type. */
	public <T extends IConstraint> String getDescription(Class<T> constraintEltClass);
}
